Fix OS_CLOUD export for image validation
[releng/global-jjb.git] / shell / tox-run.sh
index 7abdeea..e87c98f 100644 (file)
@@ -1,4 +1,4 @@
-#!/bin/bash
+#!/bin/bash -l
 # SPDX-License-Identifier: EPL-1.0
 ##############################################################################
 # Copyright (c) 2017 The Linux Foundation and others.
 ##############################################################################
 echo "---> tox-run.sh"
 
-# shellcheck source=/tmp/v/tox/bin/activate disable=SC1091
-source "/tmp/v/tox/bin/activate"
-
-# Ensure we fail the job if any steps fail.
-# DO NOT set -u as virtualenv's activate script has unbound variables
-set -e -o pipefail
-
 ARCHIVE_TOX_DIR="$WORKSPACE/archives/tox"
 mkdir -p "$ARCHIVE_TOX_DIR"
-cd "$WORKSPACE/$TOX_DIR"
+cd "$WORKSPACE/$TOX_DIR" || exit 1
 
 if [ -d "/opt/pyenv" ]; then
     echo "---> Setting up pyenv"
     export PYENV_ROOT="/opt/pyenv"
     export PATH="$PYENV_ROOT/bin:$PATH"
+    PYTHONPATH="$(pwd)"
+    export PYTHONPATH
+    export TOX_TESTENV_PASSENV=PYTHONPATH
 fi
 
-set +e  # Allow detox to fail so that we can collect the logs in the next step
-if [ ! -z "$TOX_ENVS" ]; then
-    detox -e "$TOX_ENVS"  | tee -a "$ARCHIVE_TOX_DIR/detox.log"
-    detox_status="${PIPESTATUS[0]}"
+PARALLEL="${PARALLEL:-true}"
+if [ "${PARALLEL}" = true ]; then
+    if [ -n "$TOX_ENVS" ]; then
+        tox -e "$TOX_ENVS" --parallel auto --parallel-live | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    else
+        tox --parallel auto --parallel-live | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    fi
 else
-    detox | tee -a "$ARCHIVE_TOX_DIR/detox.log"
-    detox_status="${PIPESTATUS[0]}"
+    if [ -n "$TOX_ENVS" ]; then
+        tox -e "$TOX_ENVS" | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    else
+        tox | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    fi
 fi
 
 # Disable SC2116 as we want to echo a space separated list of TOX_ENVS
 # shellcheck disable=SC2116
 for i in .tox/*/log; do
-    tox_env=$(echo $i | awk -F'/' '{print $2}')
+    tox_env=$(echo "$i" | awk -F'/' '{print $2}')
     cp -r "$i" "$ARCHIVE_TOX_DIR/$tox_env"
 done
-set -e  # Logs collected so re-enable
 
 echo "Completed tox runs."
 
-test "$detox_status" -eq 0 || exit "$detox_status"
+
+# If docs are generated push them to archives.
+DOC_DIR="${DOC_DIR:-docs/_build/html}"
+if [[ -d "$DOC_DIR" ]]; then
+    echo "---> Archiving generated docs"
+    mv "$DOC_DIR" archives/
+fi
+
+test "$tox_status" -eq 0 || exit "$tox_status"